// timeHeapDestroyDlg.cpp : implementation file
//

#include "stdafx.h"
#include "timeHeapDestroy.h"
#include "timeHeapDestroyDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define DEFAULT_NUM_ITEMS 10000000

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTimeHeapDestroyDlg dialog

CTimeHeapDestroyDlg::CTimeHeapDestroyDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTimeHeapDestroyDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTimeHeapDestroyDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTimeHeapDestroyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTimeHeapDestroyDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTimeHeapDestroyDlg, CDialog)
	//{{AFX_MSG_MAP(CTimeHeapDestroyDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_EN_CHANGE(IDC_EDIT_COUNT, OnChangeEditCount)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTimeHeapDestroyDlg message handlers

BOOL CTimeHeapDestroyDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	SetDlgItemInt(IDC_EDIT_COUNT, DEFAULT_NUM_ITEMS, FALSE);
	OnChangeEditCount();

	displayResult(IDC_STATIC_DEALLOCATIONS_1, 0);
	displayResult(IDC_STATIC_DEALLOCATIONS_2, 0);
	SetDlgItemText(IDC_STATIC_INFO, _T(""));
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTimeHeapDestroyDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTimeHeapDestroyDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTimeHeapDestroyDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTimeHeapDestroyDlg::OnChangeEditCount() 
{
	CString	text;
	CWnd	*wnd = GetDlgItem(IDOK);

	GetDlgItemText(IDC_EDIT_COUNT, text);
	if (wnd != NULL)
		wnd->EnableWindow(text.GetLength() > 0);
}

void CTimeHeapDestroyDlg::OnCancel() 
{
	CDialog::OnCancel();
}

void CTimeHeapDestroyDlg::OnOK() 
{
	DWORD	count;
	DWORD	time1, time2;

	count = GetDlgItemInt(IDC_EDIT_COUNT, NULL, FALSE);

	BeginWaitCursor();
	
	time1 = doTiming(count, FALSE);
	displayResult(IDC_STATIC_DEALLOCATIONS_1, time1);
	
	time2 = doTiming(count, TRUE);
	displayResult(IDC_STATIC_DEALLOCATIONS_2, time2);

	SetDlgItemText(IDC_STATIC_INFO, _T(""));

	EndWaitCursor();
}

// demonstration code to show that for some tasks, if you don't need to keep a heap around
// destroying it and starting over is the much more efficient thing to do

DWORD CTimeHeapDestroyDlg::doTiming(DWORD	count,
									int		doHeapDestroy)
{
	HANDLE	hHeap;
	void	**ptrs;

	// storage for the allocations we're going to make

	ptrs = new void *[count];
	if (ptrs == NULL)
		return 0;

	// work with a new heap each time
	// initial size is 1MB, heap is growable

	hHeap = HeapCreate(0, 0x00100000, 0);

	// always seed the random numbers so that each time through we get the same sequence of allocations

	srand(1);

	DWORD	i;

	// do the allocations

	SetDlgItemText(IDC_STATIC_INFO, _T("Performing allocations..."));
	for(i = 0; i < count; i++)
	{
		DWORD	size;

		// allocate, but limit to 16K, to make sure we don't ask for too much memory!

		size = rand() % 0x3fff;
		ptrs[i] = HeapAlloc(hHeap, 0, size);

		// reallocate as well, to cause a bit of fragmentation in the heap

		size = rand() % 0x7fff;
		ptrs[i] = HeapReAlloc(hHeap, 0, ptrs[i], size);
	}

	// do the cleanup
	// use GetTickCount() for simple, easy timing

	DWORD	time_start, time_end;

	if (doHeapDestroy)
	{
		SetDlgItemText(IDC_STATIC_INFO, _T("Timing deallocations: HeapDestroy()"));

		// just destroy the heap

		time_start = GetTickCount();
		HeapDestroy(hHeap);
		time_end = GetTickCount();

		hHeap = NULL;
	}
	else
	{
		SetDlgItemText(IDC_STATIC_INFO, _T("Timing deallocations: HeapFree() + HeapDestroy()"));

		// deallocate the allocations, then destroy the heap

		time_start = GetTickCount();
		for(i = 0; i < count; i++)
		{
			HeapFree(hHeap, 0, ptrs[i]);
		}

		HeapDestroy(hHeap);
		time_end = GetTickCount();

		hHeap = NULL;
	}

	// tidy up

	delete [] ptrs;

	return time_end - time_start;
}

void CTimeHeapDestroyDlg::displayResult(UINT	id,
										DWORD	time)
{
	DWORD	milli, second, minute, hour;
	TCHAR	text[100];

	milli = time % 1000;
	hour = time / (1000 * 60 * 60);

	minute = time - (hour * 1000 * 60 * 60);
	second = minute;
	minute = minute / (1000 * 60);

	second = second - (minute * 1000 * 60);
	second = second / 1000;

	_stprintf(text, _T("%02d:%02d:%02d.%03d"), hour, minute, second, milli);
	SetDlgItemText(id, text);
}
